using System;
using System.Collections.Generic;
using System.Drawing;
#pragma warning disable 1591	//stops XML warning

namespace QTPlugin
{
	/// <summary>
	/// 
	/// </summary>
	public class TabBarOption
	{
		private Dictionary<int, object> dic = new Dictionary<int, object>();

		public TabBarOption()
		{
		}

		public TabBarOption( Dictionary<int, object> option_value_pairs )
		{
			this.dic = option_value_pairs;
		}



		public void SetValue( TabBar_Options_Boolean option, bool value )
		{
			this.dic[(int)option] = value;
		}

		public void SetValue( TabBar_Options_Int option, int value )
		{
			this.dic[(int)option] = value;
		}

		public void SetValue( TabBar_Options_String option, string value )
		{
			if( value == null )
				value = String.Empty;

			this.dic[(int)option] = value;
		}

		public void SetValue( TabBar_Options_Color option, Color value )
		{
			this.dic[(int)option] = value;
		}

		public void SetValue( TabBar_Options_Misc option, object value )
		{
			this.dic[(int)option] = value;
		}

		public void SetValues( Dictionary<int, object> option_value_pairs )
		{
			foreach( int option in option_value_pairs.Keys )
			{
				this.dic[option] = option_value_pairs[option];
			}
		}



		public bool TryGetValue( TabBar_Options_Boolean option, out bool value )
		{
			object o;
			if( this.dic.TryGetValue( (int)option, out o ) && o is bool )
			{
				value = (bool)o;
				return true;
			}

			value = false;
			return false;
		}

		public bool TryGetValue( TabBar_Options_Int option, out int value )
		{
			object o;
			if( this.dic.TryGetValue( (int)option, out o ) && o is int )
			{
				value = (int)o;
				return true;
			}

			value = 0;
			return false;
		}

		public bool TryGetValue( TabBar_Options_String option, out string value )
		{
			object o;
			if( this.dic.TryGetValue( (int)option, out o ) && o is string )
			{
				value = (string)o;
				return true;
			}

			value = null;
			return false;
		}

		public bool TryGetValue( TabBar_Options_Color option, out Color value )
		{
			object o;
			if( this.dic.TryGetValue( (int)option, out o ) && o is Color )
			{
				value = (Color)o;
				return true;
			}

			value = Color.Empty;
			return false;
		}

		public bool TryGetValue( TabBar_Options_Misc option, out object value )
		{
			return this.dic.TryGetValue( (int)option, out value );
		}

		public Dictionary<int, object> Dictionary
		{
			get
			{
				return this.dic;
			}
		}
	}

	public enum TabBar_Options_Boolean
	{
		//bool 
		ActivateNew = 0,
		ReuseTab,
		CloseAllOnGroup,
		Tooltip,
		XButtons,
		NavButtons,
		TabHistory,
		RecentFiles,
		DragDrop,
		RenameAmbiguous,
		MiddleClickFolder,
		UpOneLevelOnDblClick,
		NoWindowResize,
		SaveTransparency,
		CaptureProcess,
		ShowFolderTreeOnNewProcess,
		NoCaptureWindow,
		HScrollShiftWheel,
		ChangeViewModeCtrlWheel,
		NoCloseWindow,
		NoCloseLocked,
		RestoreTabs,
		RestoreLocked,
		UseTabSkin,
		ShowFolderIcon,
		ActiveTabFontBold,
		DrawToolBarBackground,
		HideMenuBar,
		XPCompatibleBSKey,
		FullRowSelect,
		GridLines,
		ListViewAlternateColor,
		ShowPreviewTip,
		PreviewTipMode_ShiftKey,
		ShowSubDirTip,
		SubDirTipMode_ShiftKey,
		SubDirTipMode_PreviewTip,
		SubDirTipMode_HiddenFiles,
		SubDirTipMode_SystemFiles,
		SubDirTipMode_Files,
		SelectionOnRenaming,
		SendToTrayOnClose,
	}

	public enum TabBar_Options_Int
	{
		//int
		NavButtonPosition = 0x10000,
		TabHistoryMax,
		NewTabLocation,
		ActiveTabOnClose,
		TabDoubleClicked,
		BarDoubleClicked,
		MultipleRows,
		MiddleClickFolderAction,
		TabHeight,
		TabWidthMode,
		TabWidthFixed,
		TabWidthMax,
		TabWidthMin,
		PreviewTipMaxWidth,
		PreviewTipMaxHeight,
	}

	public enum TabBar_Options_String
	{
		//string
		LanguageFilePath = 0x20000,
		BarDoubleClickedPath,
		TabSkinPath,
		TabFontFamilyName,
		PluginLanguageFilePath,
	}

	public enum TabBar_Options_Color
	{
		//Color
		TabTitleActiveColor = 0x40000,
		TabTitleInctiveColor,
		ToolbarBackgroundColor,
		AlternateTextColor,
		AlternateBackgourndColor,
		ClassicHiliteColor,
	}

	public enum TabBar_Options_Misc
	{
		//other 
		TabSkinMargins = 0x80000,			//System.Windows.Forms.Padding
		TabFontSize,						//float
		PreviewTipTextExtensions,			//string[]
	}


}